---
title: "FreeBSD 13.5-RELEASE Release Notes"
sidenav: download
---

:releaseCurrent: 13.5-RELEASE
:releaseBranch: 13-STABLE
:releasePrev: 13.4-RELEASE
:releaseNext: 13.5-RELEASE
:releaseType: "release"

include::shared/en/urls.adoc[]

= FreeBSD {releaseCurrent} Release Notes
:doctype: article
:toc: macro
:toclevels: 1
:icons: font

== Abstract

[.abstract-title]
The release notes for FreeBSD {releaseCurrent} contain a summary of the changes made to the FreeBSD base system on the {releaseBranch} development line.
This document lists applicable security advisories that were issued since the last release, as well as significant changes to the FreeBSD kernel and userland.
Some brief remarks on upgrading are also presented.

[[intro]]
== Introduction

This document contains the release notes for FreeBSD {releaseCurrent}.
It describes recently added, changed, or deleted features of FreeBSD.
It also provides some notes on upgrading from previous versions of FreeBSD.

The {releaseType} distribution to which these release notes apply represents the latest point along the {releaseBranch} development branch since {releaseBranch} was created.
Information regarding pre-built, binary {releaseType} distributions along this branch can be found at https://www.FreeBSD.org/releases/[].

The {releaseType} distribution to which these release notes apply represents a point along the {releaseBranch} development branch since {releasePrev}.
The {releaseNext} is expected to be the final release from the {releaseBranch} branch.
Information regarding pre-built, binary {releaseType} distributions along this branch can be found at https://www.FreeBSD.org/releases/[].

This distribution of FreeBSD {releaseCurrent} is a {releaseType} distribution.
It can be found at https://www.FreeBSD.org/releases/[] or any of its mirrors.
More information on obtaining this (or other) {releaseType} distributions of FreeBSD can be found in the link:{handbook}/mirrors[Obtaining FreeBSD appendix] to the link:{handbook}/[FreeBSD Handbook].

All users are encouraged to consult the release errata before installing FreeBSD.
The errata document is updated with "late-breaking" information discovered late in the release cycle or after the release.
Typically, it contains information on known bugs, security advisories, and corrections to documentation.
An up-to-date copy of the errata for FreeBSD {releaseCurrent} can be found on the FreeBSD Web site.

This document describes the most user-visible new or changed features in FreeBSD since {releasePrev}.
In general, changes described here are unique to the {releaseBranch} branch unless specifically marked as MERGED features.

Typical release note items document recent security advisories issued after {releasePrev}, new drivers or hardware support, new commands or options, major bug fixes, or contributed software upgrades.
They may also list changes to major ports/packages or release engineering practices.
Clearly the release notes cannot list every single change made to FreeBSD between releases; this document focuses primarily on security advisories, user-visible changes, and major architectural improvements.

[[upgrade]]
== Upgrading from Previous Releases of FreeBSD

Binary upgrades between RELEASE versions (and snapshots of the various security branches) are supported using the man:freebsd-update[8] utility.
See the release-specific upgrade procedure, link:../installation/#upgrade-binary[FreeBSD {releaseCurrent} upgrade information], with more details in the FreeBSD handbook link:{handbook}cutting-edge/#freebsdupdate-upgrade[binary upgrade procedure].
This will update unmodified userland utilities, as well as unmodified GENERIC kernels distributed as a part of an official FreeBSD release.
The man:freebsd-update[8] utility requires that the host being upgraded have Internet connectivity.

Source-based upgrades (those based on recompiling the FreeBSD base system from source code) from previous versions are supported, according to the instructions in [.filename]#/usr/src/UPDATING#.

[IMPORTANT]
====
Upgrading FreeBSD should only be attempted after backing up _all_ data and configuration files.
====

[[security-errata]]
== Security and Errata

This section lists the various Security Advisories and Errata Notices since {releasePrev}.

[[security]]
=== Security Advisories

[.informaltable]
[cols="1,1,1", frame="none", options="header"]
|===
| Advisory
| Date
| Topic

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:15.bhyve.asc[FreeBSD-SA-24:15.bhyve]
|19 September 2024
|man:bhyve[8] out-of-bounds read access via XHCI emulation

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:16.libnv.asc[FreeBSD-SA-24:16.libnv]
|19 September 2024
|Integer overflow in libnv

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:17.bhyve.asc[FreeBSD-SA-24:17.bhyve]
|29 October 2024
|Multiple issues in the bhyve hypervisor

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:18.ctl.asc[FreeBSD-SA-24:18.ctl]
|29 October 2024
|Unbounded allocation in man:ctl[4] CAM Target Layer

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:19.fetch.asc[FreeBSD-SA-24:19.fetch]
|29 October 2024
|Certificate revocation list man:fetch[1] option fails

|https://www.freebsd.org/security/advisories/FreeBSD-SA-25:01.openssh.asc[FreeBSD-SA-25:01.openssh]
|29 January 2025
|OpenSSH Keystroke Obfuscation Bypass

|https://www.freebsd.org/security/advisories/FreeBSD-SA-25:02.fs.asc[FreeBSD-SA-25:02.fs]
|29 January 2025
|Buffer overflow in some filesystems via NFS

|https://www.freebsd.org/security/advisories/FreeBSD-SA-25:03.etcupdate.asc[FreeBSD-SA-25:03.etcupdate]
|29 January 2025
|Unprivileged access to system files

|https://www.freebsd.org/security/advisories/FreeBSD-SA-25:04.ktrace.asc[FreeBSD-SA-25:04.ktrace]
|29 January 2025
|Uninitialized kernel memory disclosure via man:ktrace[2]

|https://www.freebsd.org/security/advisories/FreeBSD-SA-25:05.openssh.asc[FreeBSD-SA-25:05.openssh]
|21 February 2025
|Multiple vulnerabilities in OpenSSH
|===

[[errata]]
=== Errata Notices

[.informaltable]
[cols="1,1,1", frame="none", options="header"]
|===
| Errata
| Date
| Topic

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:16.pf.asc[FreeBSD-EN-24:16.pf]
|19 September 2024
|Incorrect ICMPv6 state handling in pf

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:17.pam_xdg.asc[FreeBSD-EN-24:17.pam_xdg]
|29 October 2024
|XDG runtime directory's file descriptor leak at login

|https://www.freebsd.org/security/advisories/FreeBSD-EN-25:01.rpc.asc[FreeBSD-EN-25:01.rpc]
|29 January 2025
|NULL pointer dereference in the NFSv4 client

|https://www.freebsd.org/security/advisories/FreeBSD-EN-25:02.audit.asc[FreeBSD-EN-25:02.audit]
|29 January 2025
|System call auditing disabled by DTrace

|https://www.freebsd.org/security/advisories/FreeBSD-EN-25:03.tzdata.asc[FreeBSD-EN-25:03.tzdata]
|29 January 2025
|Timezone database information update

|===

[[userland]]
== Userland

This section covers changes and additions to userland applications, contributed software, and system utilities.

[[userland-contrib]]
=== Contributed Software

`libpcap` has been consecutively updated to 1.10.3, 1.10.4 and 1.10.5.
gitref:7aedea868535[repository=src], gitref:e6efc827e47a[repository=src] and gitref:68ddf72800f8[repository=src].
(Sponsored by	The FreeBSD Foundation)

`tpcdump` has been consecutively updated to 4.99.4 and 4.99.5.
gitref:e5258a079df3[repository=src] and gitref:094f44ea0358[repository=src].
(Sponsored by	The FreeBSD Foundation).

`tzdata` has been consecutively updated to 2024b and 2025a.
gitref:59ffae6c0c7a[repository=src] and gitref:2d6dcb4f97f8[repository=src].

`expat` has been consecutively updated to 2.6.3 and 2.6.4.
gitref:bab279022ba2[repository=src] and gitref:3d46113d2196[repository=src].

`less` has been updated to v668.
gitref:eed6d080a74f[repository=src].

`file` has been updated consecutively to 5.45 and 5.46.
gitref:90222d7fa4bb[repository=src] and gitref:dcb4ac96fcf6[repository=src].

`xz` has been updated consecutively to 5.6.2 and 5.6.3.
gitref:45230e7f9298[repository=src] and gitref:aa2f56a6ecd6[repository=src].

Some functionalities of `libusb` have been merged from the 1.0.16 version.
gitref:02ef8e4061ab[repository=src].
(Sponsored by	The FreeBSD Foundation)

`tzcode` has been updated to 2024b.
gitref:036ce2460cbc[repository=src].
(Sponsored by	Klara, Inc.)

With multiple intermediary commits and version updates llvm-project has been updated to release/19.x llvmorg-19.1.7-0-gcd708029e0b2.
gitref:2611bae42b7d[repository=src].
This updates llvm, clang, compiler-rt, libc++, libunwind, lld, lldb and openmp.

man:libarchive[3] has been updated to 3.7.7.
gitref:6c7993ffba96[repository=src].

man:unbound[8] has been consecutively updated to 1.21.0, 1.21.1 and 1.22.0.
gitref:7217d74d1085[repository=src], gitref:d10c9c15a3a4[repository=src] and gitref:741bb8476204[repository=src].

wpa has been updated to 2.11.
gitref:87b2a3073aaf[repository=src].

`bc` has been consecutively updated to 7.0.0 and 7.0.2.
gitref:1d669b3d15bc[repository=src] and gitref:bb18c65a9177[repository=src].

`sqlite3` has been updated to 3.46.1.
gitref:bee9d305ee57[repository=src].

OpenSSH has been consecutively updated to 9.8p1, 9.9p1 and 9.9p2.
gitref:b74bb7f01193[repository=src], gitref:cb8e164fbb15[repository=src] and gitref:31dcdee20afc[repository=src].
(Sponsored by	The FreeBSD Foundation)

[[userland-deprecated-programs]]
=== Deprecated Applications and Features

Update deprecation warning to note that man:gvinum[8] is removed in 15.0.
gitref:8126ed28bda6[repository=src].

man:shar[1] has been deprecated and deprecation notice has been added.
gitref:0d946859c994[repository=src].
The man:shar[1] program is simple, but the fundamental idea of a sh archive is
risky at best and one that probably should not be promoted as prominently as a program in `$PATH` and a manpage.
The same functionality can easily be found in man:tar[1] instead.

While OpenSSH plans to remove support for the DSA signature algorithm in early 2025, FreeBSD 13.5-RELEASE and the stable/13 branch are not expected to receive upstream vendor code updates.
However, potential security issues in imported components may necessitate the removal of DSA signature support during the branch's lifetime.

[[drivers]]
== Devices and Drivers

This section covers changes and additions to devices and device drivers since {releasePrev}.

[[drivers-device]]
=== Device Drivers

Purism coreboot keyboards support was added.
gitref:dfdcb418d7b8[repository=src].

Support of Realtek 8156/8156B was moved from man:cdce[4] to man:ure[4].
gitref:1b0af7617e6c[repository=src].
(Sponsored by	The FreeBSD Foundation)

Support for Brainboxes USB-to-Serial adapters were added.
gitref:c3a377dbbb87[repository=src].

[[drivers-removals]]
=== Deprecated and Removed Drivers

man:agp[4] has been planned for removal in FreeBSD 15.0, and the man page now states that it is deprecated.
gitref:8375d2b9c653[repository=src].

[[storage]]
== Storage

This section covers changes and additions to file systems and other storage subsystems, both local and networked.

[[storage-general]]
=== General Storage

Allow to pass {NGROUPS_MAX} + 1 groups in man:mountd[8].
gitref:927d7d57793a[repository=src].
NGROUPS_MAX is just the minimum maximum of the number of allowed supplementary groups.
The actual runtime value may be greater.
Allow more groups to be specified accordingly.
man:nmount[2] has been changed similarly.
(Sponsored by The FreeBSD Foundation)

Defer the January 19, 2038 date limit in UFS1 filesystems to February 7, 2106.
gitref:dfe803fdbc54[repository=src].

Add microsecond precision for disk latency for man:gstat[8].
gitref:d81b0f5e43f0[repository=src].
(Sponsored by	Postgres Professional)

Fix cd9660 duplicate directory names.
gitref:79778b7aafc8[repository=src].
This issue was at first introduced in FreeBSD 14.2-RELEASE which caused it creating cd9660 images with duplicate short (level 2) names in the installer images.
(Sponsored by	The FreeBSD Foundation)

[[network]]
== Networking

This section describes changes that affect networking in FreeBSD.

[[network-general]]
=== General Network

Convert PF_DEFAULT_TO_DROP into a vnet loader tunable `net.pf.default_to_drop`.
gitref:cb162f659578[repository=src].
gitref:7f7ef494f11d[repository=src] introduced a compile time option PF_DEFAULT_TO_DROP to make the man:pf[4] default rule to drop.
While this change exposes a vnet loader tunable `net.pf.default_to_drop` so that users can change the default rule without re-compiling the man:pf[4] module.
This change is similar to that for IPFW gitref:5f17ebf94db5[repository=src].

Add AIM to man:igc[4] driver.
gitref:eaa616f02193[repository=src].
man:igc[4] is derived from man:igb[4] and has never had an AIM implementation. The same algorithm from e1000 is appropriate here.
The AIM algorithm was re-introduced from the older igb or out of tree driver, and then modernized with permission to use Intel code from other drivers.
(Sponsored by	Rubicon Communications, LLC/Netgate and BBOX.io)

Re-add AIM to e1000 driver.
gitref:a527aa7a7f62[repository=src].
(Sponsored by	Rubicon Communications, LLC/Netgate and BBOX.io)

Old itr sysctl handler has been removed from the e1000 driver.
gitref:a42c3e61504b[repository=src].
With the new AIM code, it is expected most users will not need to manually tune this.
(Sponsored by	BBOX.io)

Improve SFP support man:igb[4] driver.
gitref:cf6a8711e437[repository=src].
(Sponsored by	Nozomi Networks and BBOX.io)

man:igb[4] driver version has been updated to 2.5.28-fbsd.
gitref:a446e9481531[repository=src].

`if_bypass` from man:ixgbe[4] has been updated to ix-3.3.38.
gitref:5121d1b91209[repository=src].

`if_ix` from man:ixgbe[4] has been updated with ix-3.3.38 changes.
gitref:78d9eb6de856[repository=src].

`ixgbe_mbx` from man:ixgbe[4] has been updated with ix-3.3.38 changes.
gitref:fa00169e26ff[repository=src].

`ixgbe_phy` from man:ixgbe[4] has been updated with ix-3.3.38 changes.
gitref:b1dadbcebdfd[repository=src].

`if_sriov` from man:ixgbe[4] has been updated with ix-3.3.38 changes.
gitref:deea1953820e[repository=src].

man:ena[4] driver version has been updated to 2.8.0.
gitref:2e7ba5d93e2d[repository=src].
(Sponsored by Amazon, Inc.)

[[hardware]]
== Hardware Support

This section covers general hardware support for physical machines, hypervisors, and virtualization environments, as well as hardware changes and updates that do not otherwise fit in other sections of this document.

Please see link:https://www.freebsd.org/releases/13.5R/hardware[the list of hardware] supported by {releaseCurrent}, as well as link:https://www.freebsd.org/platforms/[the platforms page] for the complete list of supported CPU architectures.

[[hardware-virtualization]]
=== Virtualization Support

Teach man:sysctl[8] to attach and run itself in a jail.
gitref:5b0a5d8c1ea3[repository=src].
This allows the parent jail to retrieve or set kernel state when child does not have man:sysctl[8] installed (for example light weighted OCI containers or slim jails).
This is especially useful when manipulating jail prison or vnet sysctls.
For example, `sysctl -j foo -Ja` or `sysctl -j foo net.fibs=2`.

Teach man:ip6addrctl[8] to attach and run itself in a jail.
gitref:fa9926a62ae3[repository=src].
This will make it easier to manage address selection policies of vnet jails, especially for those light weighted OCI containers or slim jails.

Enable vnet man:sysctl[9] variables to be loader tunable.
gitref:d2a999c2e0a0[repository=src].
Completes phase two of gitref:3da1cf1e88f8[repository=src].
The meaning of the flag CTLFLAG_TUN is extended to automatically check if there is a kernel environment variable which shall initialize the sysctl during early boot.
In memoriam of Hans Petter Selasky.

Add flags to filter jail prison and vnet variables via man:sysctl[8].
gitref:09cbd68e4e47[repository=src].
So users do not have to contact the source code to tell whether a variable is a jail prison / vnet one or not.

Define a common `mac` node for jail parameters of MAC.
gitref:ae2383c0dd16[repository=src].
To be used by MAC/do.
(Sponsored by The FreeBSD Foundation)

`ORACLE VMSIZE` was bumped to accommodate growth.
gitref:75cd2f886164[repository=src].

OCI was renamed to ORACLE in releng tooling.
gitref:aad6a5f96b78[repository=src].
This allows future releng tooling to use OCI for the industry standard Open Container Initiative tooling, reducing potential for confusion Oracle Cloud Infrastructure.
(Sponsored by	SkunkWerks, GmbH)

[[documentation]]
== Documentation

This section covers changes to manual (man:man[1]) pages and other documentation shipped with the base system.

[[man-pages]]
=== Man Pages

Refer to man:graid[8] and man:zfs[8] instead of man:gvinum[8] in man:ccdconfig[8].
gitref:9e3c356f11a9[repository=src].

man:ixgbe[4] has been renamed to man:ix[4].
gitref:c07626eaa21a[repository=src].

[[ports]]
== Ports Collection and Package Infrastructure

This section covers changes to the FreeBSD Ports Collection, package infrastructure, and package maintenance and installation tools.

[[ports-packages]]
=== Packaging Changes

The KDE desktop environment has been removed from the installer images due to compatibility issues with OpenSSL 1.1.1 and upcoming package breakages.

[[installer]]
=== Installation and Upgrading

An option was added to edit the ZFS pool creation options in bsdinstall zfsboot.
gitref:6258b5bf0670[repository=src].
This allows the default options (`-O compress=lz4 -O atime=off`) to be overridden, before the ZFS boot pool is created.
For example, to set the compression algorithm to something different.

Chase location of pkg repo databases.
gitref:ef6b3c58883d[repository=src].
pkg used to store copies of upstream repository databases in `/var/db/pkg/repo-\*.sqlite`.
About a year ago this was moved to `/var/db/pkg/repos/*/`, resulting in FreeBSD cloud images no longer having those databases removed.
(Sponsored by	Amazon)

[[future-releases]]
== General Notes Regarding Future FreeBSD Releases
FreeBSD 15.0 is not expected to include support for 32-bit platforms other than armv7.
The armv6, i386, and powerpc platforms are deprecated and will be removed.
64-bit systems will still be able to run older 32-bit binaries.

The FreeBSD Project expects to support armv7 as a Tier 2 architecture in FreeBSD 15.0 and stable/15.
However, the Project also anticipates that armv7 may be removed in FreeBSD 16.0.
The Project will provide an update on the status of armv7 for both 15.x and 16.x at the time of 15.0 release.

Support for executing 32-bit binaries on 64-bit platforms via the `COMPAT_FREEBSD32` option will continue for at least the stable/15 and stable/16 branches.
Support for compiling individual 32-bit applications via `cc -m32` will also continue for at least the stable/15 branch, which includes suitable headers in [.filename]#/usr/include# and libraries in [.filename]#/usr/lib32#.

Ports will not include support for deprecated 32-bit platforms for FreeBSD 15.0 and later releases.
These future releases will not include binary packages or support for building packages from ports for deprecated 32-bit platforms.

The FreeBSD stable/14 and earlier branches will retain existing 32-bit kernel and world support.
Ports will retain existing support for building ports and packages for 32-bit systems on stable/14 and earlier branches as long as those branches are supported by the ports system.
However, all 32-bit platforms are Tier-2 or Tier-3, and support for individual ports should be expected to degrade as upstreams deprecate 32-bit platforms.

With the current support schedule, stable/14 will reach end of life (EOL) around 5 years after the release of FreeBSD 14.0-RELEASE.
The EOL of stable/14 will mark the end of support for deprecated 32-bit platforms, including source releases, pre-built packages, and support for building applications from ports.
With the release of 14.0-RELEASE in November 2023, support for deprecated 32-bit platforms will end in November 2028.

The Project may choose to alter this approach when FreeBSD 15.0 is released by extending some level of support for one or more of the deprecated platforms in 15.0 or later.
Any alterations will be driven by community feedback and committed efforts to support these platforms.
